/*
Name: MESHAL ALI OKAIRY
Email: mokairy@stu.kau.edu.sa
ID: 2237836
Section: F12
*/

package mainprogram;

import java.io.PrintWriter;

public class Course {

    private String courseName;
    private int courseNumber;
    private Instructor head;

    public Course() {
        this.head = null;

    }

    public Course(int number) {

        this.courseNumber = number;
        this.head = null;

    }

//    public Course(String name, int number) {
//
//        this.courseNumber = number;
//        this.courseName = name;
//        this.head = null;
//
//    }
////////////////////////////////////////////////////////
    public String getCourseName() {
        return courseName;
    }

    public void setCourseName(String courseName) {
        this.courseName = courseName;
    }

    public int getCourseNumber() {
        return courseNumber;
    }

    public void setCourseNumber(int courseNumber) {
        this.courseNumber = courseNumber;
    }

    public Instructor getHead() {
        return head;
    }

/////////////////////////////////////////////////////////////////////////////////////////////////
    public boolean isEmpty() {
        return head == null;
    }
/////////////////////////////////////////////////////////////////////////////////////////////////

    public void addInstructor(int ID, String fName, String lName) {
        head = addInstructor(head, ID, fName, lName);
    }

    private Instructor addInstructor(Instructor head, int ID, String fName, String lName) {
        if (isEmpty() || head.getID() > ID) {
            head = new Instructor(ID, fName, lName, "CPCS" + courseNumber, head);
            return head;
        } else {
            Instructor helpPtr = head;

            while (helpPtr.getNext() != null) {
                if (helpPtr.getNext().getID() > ID) {
                    break;
                }
                helpPtr = helpPtr.getNext();

            }
            helpPtr.setNext(new Instructor(ID, fName, lName, "CPCS" + courseNumber, null));

        }
        return head;

    }
/////////////////////////////////////////////////////////////////////////////////////////////////

    public void setCoord(int ID) {
        head = setCoord(head, ID);
    }

    private Instructor setCoord(Instructor head, int ID) {

        Instructor helpPtr = head;
        while (helpPtr != null) {
            if (helpPtr.getID() == ID) {
                helpPtr.setCootdinator(true);

            } else {
                helpPtr.setCootdinator(false);
            }
            helpPtr = helpPtr.getNext();
        }

        return head;
    }
/////////////////////////////////////////////////////////////////////////////////////////////////

    public void printCourses(PrintWriter output) {
        printCourses(head, output);
    }

    private void printCourses(Instructor head, PrintWriter output) {
        Instructor helpPtr = head;
        while (helpPtr != null) {
            if (helpPtr.getID() < 10) {
                output.printf("\t%-10s %-30s %-25s %n", "00" + helpPtr.getID(), helpPtr.getfName() + " " + helpPtr.getlName(), helpPtr.getCootdinator());
            } else {
                output.printf("\t%-10s %-30s %-25s %n", "0" + helpPtr.getID(), helpPtr.getfName() + " " + helpPtr.getlName(), helpPtr.getCootdinator());
            }

            helpPtr = helpPtr.getNext();
        }
        output.println("");

    }
///////////////////////////////////////////////////////////////////////////////////////////////////

    public Instructor coordinatedBy() {
        return coordinatedBy(head);
    }

    private Instructor coordinatedBy(Instructor head) {
        Instructor helpPtr = head;

        while (helpPtr != null) {
            if (helpPtr.isCootdinator()) {
                return helpPtr;
            }
            helpPtr = helpPtr.getNext();
        }
        return null;
    }
/////////////////////////////////////////////////////////////////////////////////////////////////

    public int numOfInstructor() {
        return numOfInstructor(head);
    }

    private int numOfInstructor(Instructor head) {
        Instructor helpPtr = head;
        int count = 0;

        while (helpPtr != null) {
            count++;
            helpPtr = helpPtr.getNext();

        }
        return count;

    }
/////////////////////////////////////////////////////////////////////////////////////////////////    

    public Instructor searchInstructorByID(int ID) {
        return searchInstructorByID(head, ID);
    }

    private Instructor searchInstructorByID(Instructor head, int ID) {
        Instructor helpPtr = head;
        while (helpPtr != null) {
            if (helpPtr.getID() == ID) {
                return helpPtr;
            }
            helpPtr = helpPtr.getNext();
        }

        return null;

    }
/////////////////////////////////////////////////////////////////////////////////////////////////

    public Instructor deleteInstructorByID(int ID) {
        return deleteInstructorByID(head, ID);
    }

    private Instructor deleteInstructorByID(Instructor head, int ID) {
        Instructor helpPtr = head;

        while (helpPtr != null) {

            if (helpPtr.getNext().getID() == ID) {

                helpPtr.setNext(helpPtr.getNext().getNext());
                return head;
            }
            helpPtr = helpPtr.getNext();
        }

        return head;
    }
/////////////////////////////////////////////////////////////////////////////////////////////////

}
