//Q1
package LinkListUpdated;

import java.util.Scanner;

public class LLdemo {

    public static void main(String[] args) {
       
        Scanner input = new Scanner(System.in);

        
        int choice; 
        int value;  

        
        LinkedList myList = new LinkedList();

        
        do {
            
            showMenu();
            choice = input.nextInt();

           
            if (choice == 1) {
                System.out.print(">    What value do you want to insert: ");
                value = input.nextInt();

                if (myList.search(value)) {
                    System.out.println(">    " + value + " already exists in the list. Duplicates are not allowed.");
                } else {
                    myList.insert(value);
                    System.out.println(">    " + value + " was successfully inserted into the list.");
                }
                System.out.println();
            } 
            else if (choice == 2) {
                System.out.print(">    What value do you want to delete: ");
                value = input.nextInt();

                if (myList.search(value)) {
                    myList.delete(value);
                    System.out.println(">    " + value + " was successfully deleted from the list.");
                } 
                else {
                    System.out.println(">    " + value + " is not in the list (no delete needed).");
                }
                System.out.println();

                System.out.println();

            } else if (choice == 3) {
                if (myList.isEmpty())
                    System.out.println(">    Error: cannot print nodes (the list is empty)");
                else {
                    System.out.println(">    Deleting all nodes smaller than the average ");
                    myList.deleteAvr();
                    System.out.println(">    Done.\n>    All nodes smaller than the average has been removed");
                    
                    
                }
                
                
                System.out.println();
            } else if (choice == 4) {
                if (myList.isEmpty()) {
                    System.out.println(">    Error: cannot print nodes (the list is empty)");
                    System.out.println();
                } else {
                    System.out.println(">    Printing All Nodes:");
                    System.out.print(">    ");
                    myList.PrintList();
                    System.out.println();
                    System.out.println();
                }
            } else if (choice == 5) {
                if (myList.isEmpty()) {
                    System.out.println(">    Error: cannot perform sum (the tree is empty)");
                    System.out.println();
                } else {
                    System.out.println(">    The sum of all nodes is " + myList.sumNodes() + ".");
                    System.out.println();
                }

            } else if (choice == 12) {
                System.out.println(">    Goodbye!");
                System.out.println();
            } else {
                System.out.println(">    Wrong selection. Try again.");
                System.out.println();
            }

        } while (choice != 12);
    }

    public static void showMenu() {
        System.out.println("|-------------------------------------------------|");
        System.out.println("|-------      Linked List Demo (Menu)      -------|");
        System.out.println("|-------------------------------------------------|");
        System.out.println("|   1. Insert an item into the list               |");
        System.out.println("|   2. Delete an item from the list               |");
        System.out.println("|   3. Delete nodes smaller than the average      |");
        System.out.println("|   4. Print all nodes in the list                |");
        System.out.println("|   5. Print the sum of all data values           |");
        System.out.println("|   12. Quit                                      |");
        System.out.println("|-------------------------------------------------|");
        System.out.println();
        System.out.print("> Please enter your choice: ");
    }
}
