//Q1
package LinkListUpdated;

public class LinkedList {

    private LLnode head;

    public LinkedList() {
        head = null;
    }

    public boolean isEmpty() {
        return head == null;
    }
///////////////////////////////////////////////////////////////////////////////////////

    public void PrintList() {
        PrintList(head);
    }

    private void PrintList(LLnode head) {

        LLnode helpPtr = head;

        while (helpPtr != null) {

            System.out.print(helpPtr.getSize() + ", ");

            helpPtr = helpPtr.getNext();
        }
        System.out.println();
    }
///////////////////////////////////////////////////////////////////////////////////////

    public int sumNodes() {
        return sumNodes(head);
    }

    private int sumNodes(LLnode head) {
        LLnode helpPtr = head;

        int sum = 0;

        while (helpPtr != null) {

            sum += helpPtr.getSize();

            helpPtr = helpPtr.getNext();
        }
        return sum;
    }
///////////////////////////////////////////////////////////////////////////////////////

    public LLnode deleteAvr() {
        LLnode helpPtr = this.head;

        int sum = 0, count = 0;

        while (helpPtr != null) {

            sum += helpPtr.getSize();
            count++;

            helpPtr = helpPtr.getNext();

        }
        int average = sum / count;
        

        helpPtr = this.head;

        while (helpPtr != null) {
            if (head.getSize() < average) {
                head = head.getNext();
            }

            if (helpPtr.getNext() != null && helpPtr.getNext().getSize() < average) {
                helpPtr.setNext(helpPtr.getNext().getNext());
            }

            helpPtr = helpPtr.getNext();

        }

        return head;
    }
///////////////////////////////////////////////////////////////////////////////////////

    public void insert(int data) {
        head = insert(head, data);
    }

    private LLnode insert(LLnode head, int data) {
        if (head == null || head.getSize() > data) {
            head = new LLnode(data, head);
            return head;
        } else {

            LLnode helpPtr = head;

            while (helpPtr.getNext() != null) {
                if (helpPtr.getNext().getSize() > data) {
                    break;
                }
                helpPtr = helpPtr.getNext();
            }
            LLnode newNode = new LLnode(data, helpPtr.getNext());
            helpPtr.setNext(newNode);

        }

        return head;
    }
///////////////////////////////////////////////////////////////////////////////////////

    public void delete(int data) {
        head = delete(head, data);
    }

    private LLnode delete(LLnode head, int data) {
        if (!isEmpty()) {
            if (head.getSize() == data) {
                head = head.getNext();
            } else {
                LLnode helpPtr = head;

                while (helpPtr.getNext() != null) {
                    if (helpPtr.getNext().getSize() == data) {
                        helpPtr.setNext(helpPtr.getNext().getNext());
                        break;
                    }
                    helpPtr = helpPtr.getNext();
                }
            }
            return head;
        }
        return head;
    }
///////////////////////////////////////////////////////////////////////////////////////

    public boolean search(int data) {
        return search(head, data);
    }

    private boolean search(LLnode head, int data) {
        LLnode helpPtr = head;
        while (helpPtr != null) {
            if (helpPtr.getSize() == data) {
                return true;
            }
            helpPtr = helpPtr.getNext();
        }
        return false;
    }
}
